import {
  asNumber
} from "./chunk-B3AQ7EZQ.mjs";
import {
  choose
} from "./chunk-2KZ5UP6A.mjs";
import {
  asString
} from "./chunk-BDA5LB4S.mjs";

// src/types/CacheAge.ts
var ageNumber = (s) => asNumber(s.replace(/[a-z]/g, ""));
var cacheAge = {
  toMilliseconds: (ca) => choose(asString(ca)).case(
    (c) => c.endsWith("ms"),
    (c) => ageNumber(c)
  ).case(
    (c) => c.endsWith("s"),
    (c) => ageNumber(c) * 1e3
  ).case(
    (c) => c.endsWith("m"),
    (c) => ageNumber(c) * 60 * 1e3
  ).case(
    (c) => c.endsWith("h"),
    (c) => ageNumber(c) * 3600 * 1e3
  ).case(
    (c) => c.endsWith("d"),
    (c) => ageNumber(c) * 24 * 3600 * 1e3
  ).else(ca),
  toSeconds: (ca) => choose(asString(ca)).case(
    (c) => c.endsWith("ms"),
    (c) => ageNumber(c) / 1e3
  ).case(
    (c) => c.endsWith("s"),
    (c) => ageNumber(c)
  ).case(
    (c) => c.endsWith("m"),
    (c) => ageNumber(c) * 60
  ).case(
    (c) => c.endsWith("h"),
    (c) => ageNumber(c) * 3600
  ).case(
    (c) => c.endsWith("d"),
    (c) => ageNumber(c) * 24 * 3600
  ).else(ca)
};

export {
  cacheAge
};
//# sourceMappingURL=chunk-6UFIQJVC.mjs.map