import {
  ofGet
} from "./chunk-SJGQU3OG.mjs";
import {
  isFunc
} from "./chunk-PIRWVOO2.mjs";
import {
  isDefined
} from "./chunk-DEJ7A5PY.mjs";

// src/types/Text.ts
var isText = (t) => isDefined(t) && isFunc(t.toString);
var asString = (t, alt = "") => (isText(t) ? t : ofGet(alt)).toString();
var replaceAll = (origin, search, replace = "") => asString(origin).split(asString(search)).join(asString(replace));
var toWords = (input) => {
  return asString(input).replace(/(\p{Lower})(\p{Upper})/gu, "$1 $2").replace(/(\p{Upper})(\p{Upper}\p{Lower})/gu, "$1 $2").split(/[_\W]+/g).filter(Boolean);
};
var kebab = (s = "") => toWords(s).join("-").toLowerCase();
var capitalize = (s = "") => s.charAt(0).toUpperCase() + s.slice(1);

export {
  isText,
  asString,
  replaceAll,
  toWords,
  kebab,
  capitalize
};
//# sourceMappingURL=chunk-BDA5LB4S.mjs.map