import {
  toList
} from "./chunk-A7C3XND3.mjs";
import {
  ifDefined
} from "./chunk-JSON7A4X.mjs";

// src/types/Object.ts
function entries(subject) {
  return ifDefined(
    subject,
    () => toList([...Object.entries(subject), ...Object.entries(Object.getPrototypeOf(subject))]),
    () => toList()
  );
}
function values(subject) {
  return toList([...Object.values(subject), ...Object.values(Object.getPrototypeOf(subject))]);
}
function keys(subject) {
  return toList([...Object.keys(subject), ...Object.keys(Object.getPrototypeOf(subject))]);
}
function extractKeys(obj, keys2) {
  return keys2.filter((k) => k in obj).reduce(
    (acc, key) => {
      acc.keys[key] = obj[key];
      delete acc[key];
      return acc;
    },
    { keys: {}, ...obj }
  );
}

export {
  entries,
  values,
  keys,
  extractKeys
};
//# sourceMappingURL=chunk-H2762RTS.mjs.map