import {
  toResponse
} from "./chunk-IMREIDHQ.mjs";
import {
  isRestResult
} from "./chunk-64S6C743.mjs";
import {
  HttpStatus
} from "./chunk-UGUAZFM4.mjs";
import {
  RequestOptions
} from "./chunk-O75J6WWI.mjs";
import {
  cacheAge
} from "./chunk-6UFIQJVC.mjs";
import {
  choose
} from "./chunk-2KZ5UP6A.mjs";
import {
  toResult
} from "./chunk-Q3WMGUO2.mjs";
import {
  ctx
} from "./chunk-NDCIZJXB.mjs";
import {
  isDefined,
  isEmpty
} from "./chunk-DEJ7A5PY.mjs";

// src/services/AxiosProvider.ts
import axios from "axios";
var isResponse = (a) => isDefined(a?.response);
var isRequest = (a) => isDefined(a?.request);
var asResponse = (uri, verb, error) => choose(error).type(
  isResponse,
  (r) => toResponse(r.response.status, isRestResult(r.response.data) ? r.response.data : toResult(r.response.statusText, uri.path, uri), r.response.headers)
).type(isRequest, (r) => toResponse(r.request.status, toResult(r.request.message, uri.path, uri))).else((e) => toResponse(HttpStatus.InternalServerError, toResult(e.message, uri.path, uri)));
var AxiosProvider = class {
  constructor(ai = axios) {
    this.ai = ai;
  }
  execute = ({ uri, verb, body, transform = (r) => r, transformError = (r) => r, options = RequestOptions.Json }) => this.ai.request({
    url: uri.toString(),
    method: verb.toString(),
    headers: uri.isInternal && isEmpty(options.headers.Authorization) ? options.bearer(ctx.request.jwt).headers : options.headers,
    data: options.type.encode(body),
    maxRedirects: options.requestOptions.maxRedirects,
    ...options.requestOptions.timeout && { timeout: cacheAge.toMilliseconds(options?.requestOptions.timeout) },
    ...options.requestOptions.validateStatus && { validateStatus: options.requestOptions.validateStatus }
  }).then((r) => toResponse(r.status, transform(r.data), r.headers)).catch((e) => Promise.reject(asResponse(uri, verb, transformError(e))));
};

export {
  AxiosProvider
};
//# sourceMappingURL=chunk-S43CTNIK.mjs.map