import {
  Api
} from "./chunk-FFK2E2QL.mjs";
import {
  Gateway
} from "./chunk-CSKOVGAP.mjs";
import {
  toPageList
} from "./chunk-CRSP7OQT.mjs";
import {
  use
} from "./chunk-ZPNFXK7Y.mjs";

// src/services/ApiGateway.ts
var ApiGateway = class extends Gateway {
  constructor(api = new Api()) {
    super();
    this.api = api;
  }
  get(uri, options) {
    return this.api.get(uri, options).then((r) => use(r.body.data, (d) => toPageList(d?.items, { total: d?.totalItems, ...d?.meta })));
  }
  getOne(uri, options) {
    return this.get(uri, options).then((r) => r.first());
  }
  post(uri, item, options) {
    return this.api.post(uri, item, options).then((r) => r.body.data?.items.first() ?? {});
  }
  postSearch(uri, options) {
    return this.api.post(uri, options).then((r) => use(r.body.data, (d) => toPageList(d?.items, { total: d?.totalItems, ...d?.meta })));
  }
  patch(uri, item, options) {
    return this.api.patch(uri, item, options).then((r) => r.body.data?.items.first() ?? {});
  }
  put(uri, item, options) {
    return this.api.put(uri, item, options).then((r) => r.body.data?.items.first() ?? {});
  }
  delete(uri, options) {
    return this.api.delete(uri, options).then(() => true);
  }
};

export {
  ApiGateway
};
//# sourceMappingURL=chunk-ZHAVV2E5.mjs.map