import {
  Property
} from "../chunk-GCY5A63A.mjs";
import {
  SortCondition,
  toCondition
} from "../chunk-RO6COWZH.mjs";
import "../chunk-MDXL65W4.mjs";
import "../chunk-6NJ65PSU.mjs";
import "../chunk-H2762RTS.mjs";
import "../chunk-A7C3XND3.mjs";
import "../chunk-JSON7A4X.mjs";
import {
  toArray
} from "../chunk-CO2AFYVD.mjs";
import "../chunk-BDA5LB4S.mjs";
import "../chunk-SJGQU3OG.mjs";
import "../chunk-ZHXKBOK2.mjs";
import "../chunk-ZPNFXK7Y.mjs";
import "../chunk-DXQSIBC7.mjs";
import "../chunk-PIRWVOO2.mjs";
import {
  isDefined
} from "../chunk-DEJ7A5PY.mjs";
import "../chunk-4N72FQFX.mjs";

// src/data/Field.ts
var Field = class extends Property {
  is = (value) => this.condition("eq", value);
  isNot = (value) => this.condition("ne", value);
  isIn = (...value) => this.condition("in", toArray(value));
  notIn = (...value) => this.condition("nin", toArray(value));
  exists = (does) => this.condition("exists", does);
  greater = (value) => this.condition("gt", value);
  greaterEqual = (value) => this.condition("gte", value);
  less = (value) => this.condition("lt", value);
  lessEqual = (value) => this.condition("lte", value);
  asc = () => new SortCondition(this.property, 1);
  desc = () => new SortCondition(this.property, -1);
  condition = (operator, value) => toCondition(this.property, operator, value, this.options?.convert);
};
var isField = (f) => isDefined(f) && f instanceof Field;
export {
  Field,
  isField
};
//# sourceMappingURL=Field.mjs.map