import { Convert } from '../utils/Convert';
import { TypeGuard } from '../types/TypeGuard';
import type { Text } from '../types/Text';
export declare const quote: (a: unknown) => string;
export declare class Clause implements Text {
    readonly first: unknown;
    readonly operator: string;
    readonly second: unknown;
    constructor(first: unknown, operator: string, second: unknown);
    and: (other: Clause) => Clause;
    or: (other: Clause) => Clause;
    toString(): string;
}
export declare class ParathesizedClause extends Clause {
    toString(): string;
}
export declare const toClause: (first: unknown, operator: string, second: unknown, conv?: Convert) => Clause;
export declare const isClause: TypeGuard<Clause>;
