import {
  Update
} from "../chunk-FD7AIHNO.mjs";
import {
  Column
} from "../chunk-K2QIYLIW.mjs";
import {
  Count
} from "../chunk-LXENNRRB.mjs";
import {
  Delete
} from "../chunk-DF6AC3AA.mjs";
import {
  Insert
} from "../chunk-NKSCRMWF.mjs";
import {
  Join
} from "../chunk-OQNZEKWO.mjs";
import {
  Select
} from "../chunk-SSQRH66L.mjs";
import "../chunk-55SDDPJZ.mjs";
import {
  Mapper,
  mappings
} from "../chunk-YGLRUAUP.mjs";
import "../chunk-WJZFE5NE.mjs";
import "../chunk-OKPGJD64.mjs";
import {
  toUuid
} from "../chunk-LXQQ5N6S.mjs";
import {
  Database
} from "../chunk-7KQ4QLP2.mjs";
import "../chunk-GCY5A63A.mjs";
import "../chunk-MDXL65W4.mjs";
import "../chunk-6NJ65PSU.mjs";
import "../chunk-2KZ5UP6A.mjs";
import "../chunk-OFGI5FLG.mjs";
import "../chunk-NCEWAKOZ.mjs";
import "../chunk-Q3WMGUO2.mjs";
import "../chunk-5HENJTR6.mjs";
import "../chunk-LLTFR25V.mjs";
import "../chunk-WSBULPUZ.mjs";
import "../chunk-NDCIZJXB.mjs";
import "../chunk-MCCIBDEH.mjs";
import "../chunk-JVDKV5HE.mjs";
import "../chunk-WTFW6DLP.mjs";
import "../chunk-H2762RTS.mjs";
import {
  toList
} from "../chunk-A7C3XND3.mjs";
import "../chunk-JSON7A4X.mjs";
import "../chunk-CO2AFYVD.mjs";
import "../chunk-BDA5LB4S.mjs";
import "../chunk-SJGQU3OG.mjs";
import "../chunk-ZHXKBOK2.mjs";
import "../chunk-ZPNFXK7Y.mjs";
import "../chunk-DXQSIBC7.mjs";
import "../chunk-PIRWVOO2.mjs";
import "../chunk-DEJ7A5PY.mjs";
import "../chunk-4N72FQFX.mjs";

// src/sql/Table.ts
var Table = class extends Mapper {
  map = {
    ...mappings,
    column: (name, options) => new Column(this, name, options)
  };
  id = this.map.column("", { dflt: toUuid });
  constructor(options = { startFrom: "source" }) {
    super(options);
  }
  get db() {
    return Database.Default;
  }
  get count() {
    return new Count(this);
  }
  /**
   * @deprecated Deprecated since version 6.2. Please use map.column instead.
   */
  prop = (name, options) => this.map.column(name, options);
  select = (...columns) => new Select(this, toList(columns));
  insert = (fields) => new Insert(this, this.out(fields));
  update = (fields) => new Update(this, this.out(fields));
  delete = () => new Delete(this, toList());
  join = (t) => new Join(this, t);
};
export {
  Table
};
//# sourceMappingURL=Table.mjs.map