import { Convert } from './Convert';
import { Mapping } from './Mapper';
import { Get } from '../types/Get';
import { Json, JsonValue } from '../types/Json';
export type PropertyOptions<T = unknown> = {
    convert?: Convert<any, any>;
    dflt?: Get<T>;
    format?: string;
};
export declare class Property<T = unknown> implements Mapping {
    readonly property: string;
    readonly options?: PropertyOptions | undefined;
    constructor(property: string, options?: PropertyOptions | undefined);
    in: (source?: Json) => JsonValue;
    out: (source?: Json, key?: string) => JsonValue;
    toString(): string;
}
