import type { Text } from '../types/Text';
import { Id } from '../types/Id';
export declare class Sentence implements Text {
    private sentence;
    constructor(word: Text, pre?: Sentence, sentence?: Text[]);
    toString(): string;
}
declare class Topic extends Sentence {
    it: Sentence;
    anything: Sentence;
    id: (id: Id) => Sentence;
    your: (subject?: Text) => Sentence;
    a: (subject?: Text) => Sentence;
    an: (subject?: Text) => Sentence;
    any: (subjects?: Text) => Sentence;
}
declare class Verb extends Sentence {
    add: Topic;
    check: Topic;
    fetch: Topic;
    find: Topic;
    like: Topic;
    process: Topic;
    remove: Topic;
    translate: Topic;
    update: Topic;
    validate: Topic;
}
declare class Not extends Verb {
}
declare class SupportVerb extends Verb {
    not: Not;
}
declare class We extends Sentence {
    could: SupportVerb;
    did: SupportVerb;
    added: Topic;
    checked: Topic;
    fetched: Topic;
    found: Topic;
    liked: Topic;
    processed: Topic;
    removed: Topic;
    translated: Topic;
    updated: Topic;
    validated: Topic;
}
export declare const we: We;
export {};
